/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_DIETSERV                                                 */
/* Tabela : DIETSERV                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_DIETSERV'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_DIETSERV
GO

CREATE TRIGGER DTULTATU_DIETSERV
ON DIETSERV
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'DIETSERV', CDFILIAL, 'CDFILIAL=' + CDFILIAL+ ';'+
                                             'CDDIETPAD='+ CDDIETPAD+ ';'+
                                             'CDSERVFILI='+ CDSERVFILI+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE DIETSERV
      SET DTULTATUDISE = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(DIETSERV.CDDIETPAD,0)  = ISNULL(INSERTED.CDDIETPAD,0))  AND
            (ISNULL(DIETSERV.CDSERVFILI,0) = ISNULL(INSERTED.CDSERVFILI,0)) AND
            (ISNULL(DIETSERV.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0));
   END;
END;
GO

